// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from polygon_msgs:msg/Polygon2DCollection.idl
// generated code does not contain a copyright notice

#ifndef POLYGON_MSGS__MSG__DETAIL__POLYGON2_D_COLLECTION__FUNCTIONS_H_
#define POLYGON_MSGS__MSG__DETAIL__POLYGON2_D_COLLECTION__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "polygon_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "polygon_msgs/msg/detail/polygon2_d_collection__struct.h"

/// Initialize msg/Polygon2DCollection message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * polygon_msgs__msg__Polygon2DCollection
 * )) before or use
 * polygon_msgs__msg__Polygon2DCollection__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_polygon_msgs
bool
polygon_msgs__msg__Polygon2DCollection__init(polygon_msgs__msg__Polygon2DCollection * msg);

/// Finalize msg/Polygon2DCollection message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_polygon_msgs
void
polygon_msgs__msg__Polygon2DCollection__fini(polygon_msgs__msg__Polygon2DCollection * msg);

/// Create msg/Polygon2DCollection message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * polygon_msgs__msg__Polygon2DCollection__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_polygon_msgs
polygon_msgs__msg__Polygon2DCollection *
polygon_msgs__msg__Polygon2DCollection__create();

/// Destroy msg/Polygon2DCollection message.
/**
 * It calls
 * polygon_msgs__msg__Polygon2DCollection__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_polygon_msgs
void
polygon_msgs__msg__Polygon2DCollection__destroy(polygon_msgs__msg__Polygon2DCollection * msg);

/// Check for msg/Polygon2DCollection message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_polygon_msgs
bool
polygon_msgs__msg__Polygon2DCollection__are_equal(const polygon_msgs__msg__Polygon2DCollection * lhs, const polygon_msgs__msg__Polygon2DCollection * rhs);

/// Copy a msg/Polygon2DCollection message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_polygon_msgs
bool
polygon_msgs__msg__Polygon2DCollection__copy(
  const polygon_msgs__msg__Polygon2DCollection * input,
  polygon_msgs__msg__Polygon2DCollection * output);

/// Initialize array of msg/Polygon2DCollection messages.
/**
 * It allocates the memory for the number of elements and calls
 * polygon_msgs__msg__Polygon2DCollection__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_polygon_msgs
bool
polygon_msgs__msg__Polygon2DCollection__Sequence__init(polygon_msgs__msg__Polygon2DCollection__Sequence * array, size_t size);

/// Finalize array of msg/Polygon2DCollection messages.
/**
 * It calls
 * polygon_msgs__msg__Polygon2DCollection__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_polygon_msgs
void
polygon_msgs__msg__Polygon2DCollection__Sequence__fini(polygon_msgs__msg__Polygon2DCollection__Sequence * array);

/// Create array of msg/Polygon2DCollection messages.
/**
 * It allocates the memory for the array and calls
 * polygon_msgs__msg__Polygon2DCollection__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_polygon_msgs
polygon_msgs__msg__Polygon2DCollection__Sequence *
polygon_msgs__msg__Polygon2DCollection__Sequence__create(size_t size);

/// Destroy array of msg/Polygon2DCollection messages.
/**
 * It calls
 * polygon_msgs__msg__Polygon2DCollection__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_polygon_msgs
void
polygon_msgs__msg__Polygon2DCollection__Sequence__destroy(polygon_msgs__msg__Polygon2DCollection__Sequence * array);

/// Check for msg/Polygon2DCollection message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_polygon_msgs
bool
polygon_msgs__msg__Polygon2DCollection__Sequence__are_equal(const polygon_msgs__msg__Polygon2DCollection__Sequence * lhs, const polygon_msgs__msg__Polygon2DCollection__Sequence * rhs);

/// Copy an array of msg/Polygon2DCollection messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_polygon_msgs
bool
polygon_msgs__msg__Polygon2DCollection__Sequence__copy(
  const polygon_msgs__msg__Polygon2DCollection__Sequence * input,
  polygon_msgs__msg__Polygon2DCollection__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // POLYGON_MSGS__MSG__DETAIL__POLYGON2_D_COLLECTION__FUNCTIONS_H_
